package labs313674;

import javafx.scene.chart.LineChart;
import javafx.scene.CustomNode;
import javafx.scene.chart.part.NumberAxis;
import javafx.scene.chart.part.Side;


public class AnimatedLineChart extends CustomNode {

    //public properties
    public var title : String;
    public var lineName : String;
    public var xMaxValue : Integer;
    public var yMaxValue : Integer;

    //private property
    var values : LineChart.Data[];

    //public function
    public function addValue(v:Integer) {

        var arraySize : Integer = sizeof values;

        //when the line reached the right border of the graph
        if (arraySize >= xMaxValue) {

            //delete the first (left most) element in the graph
            delete values[0];

            //and shift all values left
            for (data in values) {
                data.xValue = data.xValue - 1;
            }
        }

        insert LineChart.Data { xValue:arraySize , yValue: v } into values;

    }

    init {
        insert LineChart  {
                showSymbols: false;
                title: bind title
                legendSide: Side.RIGHT
                legendVisible: true
                xAxis: NumberAxis {
                    label: "Time (sec.)"
                    lowerBound:  0
                    upperBound: bind xMaxValue
                    minorTickVisible: true
                    tickUnit: 5
                    minorTickCount: 5
                    tickLabelsVisible: false
                }
                yAxis: NumberAxis {
                    lowerBound: 0
                    upperBound: bind yMaxValue
                    formatTickLabel: function(value) { "{%.0f value}" }
                }
                data: [
                    LineChart.Series {
                        name: bind lineName
                        data: bind values
                    }
                ]
        } into children;
    }

}